#delimit;
cd "C:\Users\cemoo\Box Sync\concarry\";
use crime.2018.dta, clear;

*cd "C:\Users\cemood\Box Sync\concarry\";
*use crime.2018.dta, clear;

log using concarry.log, replace;
scalar drop _all;
drop waitp;
program drop _all;

tsset state year;
qui: tab state, gen(stdum);
qui: tab year, gen(yrdum);
drop  if state ==9;

/* population born after 1973 (post-legalized abortion cohort) */
gen p1=0;
replace p1=pp1519/5 if year>=1989 & year<=1993;
replace p1=p1+pp1519/5 if year>=1990;
replace p1=p1+pp1519/5 if year>=1991;
replace p1=p1+pp1519/5 if year>=1992;
replace p1=p1+pp1519/5 if year>=1993;

replace p1=p1+pp2024/5 if year>=1989+5;
replace p1=p1+pp2024/5 if year>=1990+5;
replace p1=p1+pp2024/5 if year>=1991+5;
replace p1=p1+pp2024/5 if year>=1992+5;
replace p1=p1+pp2024/5 if year>=1993+5;

replace p1=p1+pp2529/5 if year>=1989+10;
replace p1=p1+pp2529/5 if year>=1990+10;
replace p1=p1+pp2529/5 if year>=1991+10;
replace p1=p1+pp2529/5 if year>=1992+10;
replace p1=p1+pp2529/5 if year>=1993+10;

replace p1=p1+pp3034/5 if year>=1989+15;
replace p1=p1+pp3034/5 if year>=1990+15;
replace p1=p1+pp3034/5 if year>=1991+15;
replace p1=p1+pp3034/5 if year>=1992+15;
replace p1=p1+pp3034/5 if year>=1993+15;
gen abortion=p1;
drop p1;

/*making corrections for terrists (okl, NY, va)
  and for adding indian reservaton murders in 2017*/
replace vtmur = vtmur-186 if state==37 & year==1995;
replace crmur = crmur-186 if state==37 & year==1995;
replace vtmur=990 if state==33 & year ==2001;
replace vtmur=383 if state==47 & year ==2001;
replace crmur=xmur if xmur ~= . ;


replace prcye=l.prcye if year ==2018;
replace prcyez=(prcye+l.prcye)/2;

replace al_spir = l.al_spir if year==2018;
replace al_beer = l.al_beer if year == 2018;
replace al_wine = l.al_wine if year == 2018;


gen popx=poptot;

gen suiratio =100*(suicidesf/suicides);

replace crmurpc=100000*(crmur/poptot);
gen lcrmurpc=100*log(crmurpc);
gen homrate=100000*(vtmur/poptot);
gen homratef=100000*(vtmurf/poptot);
gen vtmurnf=vtmur-vtmurf;
gen nghomrate=100000*(vtmurnf/poptot);

 
 /* interpolate for missing values */
 
ipolate vtmur crmur , gen(xvtmur);
ipolate vtmurf crmur, gen (xvtmurf);
replace vtmurf=xvtmurf if vtmurf==.;
replace vtmur=xvtmur if vtmur==.;

gen vtmur_1=L1.vtmur;
gen vtmur_2=L2.vtmur;
gen vtmurf_1=L1.vtmurf;
gen vtmurf_2=L2.vtmurf;
gen vtmurnf_1=L1.vtmurnf;
gen vtmurnf_2=L2.vtmurnf;


gen homrate_1=L.homrate;
gen homrate_2=L.homrate;
gen homratef_1=L.homratef;
gen homratef_2=L.homratef;
gen nghomrate_1=L.nghomrate;
gen nghomrate_2=L.nghomrate;


gen lhomrate=100*log(homrate);
gen lhomratef=100*log(homratef);
gen lnghomrate=100*log(nghomrate);

gen lhomrate_1=L.lhomrate;
gen lhomrate_2=LL.lhomrate;
gen lhomratef_1=L.lhomratef;
gen lhomratef_2=LL.lhomratef;
gen lnghomrate_1=L.lnghomrate;
gen lnghomrate_2=LL.lnghomrate;


gen lcrmurpc_1=L.lcrmurpc;
gen lcrmurpc_2=LL.lcrmurpc;
gen crmurpc_1=L.crmurpc;
gen crmurpc_2=LL.crmurpc;
gen crmur_1=L.crmur;
gen crmur_2=LL.crmur;

/* prcye is prisoners in state custody at year  end */

 replace prcye   =(prcye  /poptot*1000);
 replace prcyez  =(prcyez /poptot*1000);
    gen rtpi=tpi/cpi;
 replace rtpi    =(rtpi  /poptot     ); 
 replace employ  =(employ/poptot*1000); 
 replace empmil  =(empmil/poptot*1000); 
 replace empcon  =(empcon/poptot*1000); 
 replace police  =(police/poptot*1000); 
 replace prate   =(prate             ); 
 replace unrate  =(unrate            );
 gen rwel=welfare/cpi                 ;
 replace rwel     =(rwel  /poptot*1000); 
 replace al_spir  =(al_spir /poptot*1000); 
 replace al_beer  =(al_beer /poptot*1000); 
 replace al_wine  =(al_wine /poptot*1000); 
 
 replace pq1014  =(pq1014/ poptot*100); 
 replace pq1519  =(pq1519/ poptot*100); 
 replace pq2024  =(pq2024/ poptot*100); 
 replace pq2529  =(pq2529/ poptot*100); 
 replace pq3034  =(pq3034/ poptot*100); 
 replace pq3539  =(pq3539/ poptot*100); 
 replace pq4044  =(pq4044/ poptot*100); 
 replace pq4549  =(pq4549/ poptot*100); 
 replace pq5054  =(pq5054/ poptot*100); 
 replace pq5559  =(pq5559/ poptot*100); 
 replace pq6064  =(pq6064/ poptot*100); 
 replace pq4554  =(pq4554/ poptot*100); 
 replace pq5564  =(pq5564/ poptot*100);
 replace pq6500  =(pq6500/ poptot*100);
  
 replace bmq1014  =(bmq1014/ poptot*100); 
 replace bmq1519  =(bmq1519/ poptot*100); 
 replace bmq2024  =(bmq2024/ poptot*100); 
 replace bmq2529  =(bmq2529/ poptot*100); 
 replace bmq3034  =(bmq3034/ poptot*100); 
 replace bmq3539  =(bmq3539/ poptot*100); 
 replace bmq4044  =(bmq4044/ poptot*100); 
 replace bmq4554  =(bmq4554/ poptot*100); 
 replace bmq5564  =(bmq5564/ poptot*100); 
 replace bmq6500  =(bmq6500/ poptot*100); 
 replace exec=exec/poptot*10000000;
  
  gen prcyex=L.prcye;
  replace prcye=prcyex;
  gen policex=L.police;
  replace police=policex;
  
   /*first full year after year of passage unless date is 01/01 */;
    drop shall; gen shall=0;
	replace shall=1 if stnm=="AK" & year>1994;
	replace shall=1 if stnm=="AL" & year>=1975;
    replace shall=1 if stnm=="AR" & year>1995;
    replace shall=1 if stnm=="AZ" & year>1994;
    replace shall=1 if stnm=="CO" & year>2003;
    *replace shall=1 if stnm=="CT" & year>1969;
    replace shall=1 if stnm=="FL" & year>1987;
    replace shall=1 if stnm=="GA" & year>1989;
    replace shall=1 if stnm=="IA" & year>=2011;
    replace shall=1 if stnm=="ID" & year>1990;
    replace shall=1 if stnm=="IL" & year>2013;
    replace shall=1 if stnm=="IN" & year>1980;
    replace shall=1 if stnm=="KS" & year>=2007;
    replace shall=1 if stnm=="KY" & year>1996;
    replace shall=1 if stnm=="LA" & year>1996;
    replace shall=1 if stnm=="ME" & year>1985;
    replace shall=1 if stnm=="MI" & year>2001;
    replace shall=1 if stnm=="MN" & year>2003;
    replace shall=1 if stnm=="MO" & year>2004;
    replace shall=1 if stnm=="MS" & year>1990;
    replace shall=1 if stnm=="MT" & year>1991;
    replace shall=1 if stnm=="NC" & year>1995;
    replace shall=1 if stnm=="ND" & year>1985;
    replace shall=1 if stnm=="NE" & year>=2007;
    *replace shall=1 if stnm=="NH" & year>1923;
    replace shall=1 if stnm=="NM" & year>=2004;
    replace shall=1 if stnm=="NV" & year>1995;
    replace shall=1 if stnm=="OH" & year>2004;
    replace shall=1 if stnm=="OK" & year>=1996;
    replace shall=1 if stnm=="OR" & year>=1990;
    replace shall=1 if stnm=="PA" & year>1989;
    replace shall=1 if stnm=="SC" & year>1996;
    replace shall=1 if stnm=="SD" & year>1985;
    replace shall=1 if stnm=="TN" & year>1996;
    replace shall=1 if stnm=="TX" & year>=1996;
    replace shall=1 if stnm=="UT" & year>1995;
    replace shall=1 if stnm=="VA" & year>1995;
    *replace shall=1 if stnm=="WA" & year>1935;
    replace shall=1 if stnm=="WI" & year>2011;
    replace shall=1 if stnm=="WV" & year>1989;
    replace shall=1 if stnm=="WY" & year>1995;
  
  /* fix waiting period for handguns  before 1968 */
  replace wait=0 if year<1968;
  replace wait=1 if stnm=="CA" & year>=1965;
  replace wait=1 if stnm=="CT" & year>1965;
  replace wait=1 if stnm=="IL" & year>1967;
  replace wait=1 if stnm=="RI" & year>1930;
  replace wait=1 if stnm=="SD" & year>1935;
  
  /* constitutional carry */
  /*first full year after year of passage unless date is 01/01 */;
  drop concarry;
  gen concarry=0;
  replace concarry=1 if stnm=="AK" & year>2003;
  replace concarry=1 if stnm=="AZ" & year>2010;
  replace concarry=1 if stnm=="AR" & year>2018;
  replace concarry=1 if stnm=="ID" & year>2016;
  replace concarry=1 if stnm=="KS" & year>2015;
  replace concarry=1 if stnm=="KY" & year>2019;
  replace concarry=1 if stnm=="ME" & year>2015;
  replace concarry=1 if stnm=="MS" & year>2015;
  replace concarry=1 if stnm=="MO" & year>=2017;
  replace concarry=1 if stnm=="NH" & year>2017;
  replace concarry=1 if stnm=="ND" & year>2017;
  replace concarry=1 if stnm=="OK" & year>2019;
  replace concarry=1 if stnm=="SD" & year>2019;
  replace concarry=1 if stnm=="WV" & year>2016;
  replace concarry=1 if stnm=="WY" & year>2011;
  
  /* out of sample AR KY OK SD (VT 1909) */
  

/* permit to purchase handgun and/or long gun */
  drop permit;
  gen permit=0;
  replace permit=1 if stnm=="CA" & year>1994;
  replace permit=1 if stnm=="CT" & year>1995;
  replace permit=1 if stnm=="MD" & year>2013;
  replace permit=1 if stnm=="MO" & year>1981 & year<=2007;
  replace permit=1 if stnm=="NE" & year>1991;
  
/* Saturday night special ban */
drop snsban;
gen snsban=0;
replace snsban=1 if stnm=="CA" & year>=2001;
replace snsban=1 if stnm=="HI" & year>1975;
replace snsban=1 if stnm=="IL" & year>1974;
replace snsban=1 if stnm=="MD" & year>1990;
replace snsban=1 if stnm=="MA" & year>1998;
replace snsban=1 if stnm=="MN" & year>1975;
replace snsban=1 if stnm=="SC" & year>1974 & year<=2012;

/* one gun per month law */

drop onegun;
gen onegun=0;
replace onegun=1 if stnm=="CA" & year>=2000;
replace onegun=1 if stnm=="MD" & year>1996;
replace onegun=1 if stnm=="NJ" & year>2009;
replace onegun=1 if stnm=="SC" & year>1976 & year<=2004;
replace onegun=1 if stnm=="VA" & year>1994 & year<=2012;


/* lcm, aw, snsban, concarry, permit require placebo law             */
/* 11 states have lcm bans, 12 policy changes                        */
/* 13 states have awbans                                             */
/* 5 states have permit to purchase laws, 6 policy changes           */
/* 11 states have constitutional carry laws                          */
/* 7 states have Saturday night special bans                         */
/* all other laws have a large number of policy changes              */

drop *_12; drop *_34; drop *_5;

/* federal assault weapons ban */
drop fedlaw*;

gen fedlaw=0; g fedlawsr=0; g fedlaw_5=0;
replace fedlaw=1 if year>1994 & year<=2004;
gen lcmfedst=0;
replace lcmfedst=lcm*fedlaw;
gen lcmfedst_5=L4.lcmfedst;
gen lcmfedstsr=lcmfedst-lcmfedst_5;
replace lcmfedstsr=0 if year>2004;
replace lcmfedst_5=0 if year>2004;

/* remove fractions from law dummies */

replace lcm=0 if lcm>0 & lcm<1;
replace bkgp=0 if bkgp>0 & bkgp<1;
replace shall=0 if shall>0 & shall<1;
replace syg=0 if syg>0 & syg<1;
replace mmd=0 if mmd>0 & mmd<1;
replace wait=0 if wait>0 & wait<1;
replace fse=0 if fse>0 & fse<1;
replace safe=0 if safe>0 & safe<1;
replace jban=0 if jban>0 & jban<1;
replace onegun=0 if onegun>0 & onegun<1;
replace snsban=0 if snsban>0 & snsban<1;
*replace concarry=0 if concarry>0 & concarry<1;
replace permit=0 if permit>0 & permit<1;


gen lcm_5=L4.lcm;
gen lcmsr=lcm-lcm_5;
gen bkgp_5=L4.bkgp;
gen bkgpsr=bkgp-bkgp_5;
gen shall_5=L4.shall;
gen shallsr=shall-shall_5;
gen syg_5=L4.syg;
gen sygsr=syg-syg_5;
gen mmd_5=L4.mmd;
gen mmdsr=mmd-mmd_5;
gen wait_5=L4.wait;
gen waitsr=wait-wait_5;
gen fse_5=L4.fse;
gen fsesr=fse-fse_5;
gen safe_5=L4.safe;
gen safesr=safe-safe_5;
gen jban_5=L4.jban;
gen jbansr=jban-jban_5;
gen onegun_5=L4.onegun;
gen onegunsr=onegun-onegun_5;
gen snsban_5=L4.snsban;
gen snsbansr=snsban-snsban_5;
gen permit_5=L4.permit;
gen permitsr=permit-permit_5;
gen tis_5=L4.tis;
gen tissr=tis-tis_5;
gen strike3_5=L4.strike3;
gen strike3sr=strike3-strike3_5;

gen concarry_0=concarry;
gen concarry_1=L1.concarry;
gen concarry_2=L2.concarry;
gen concarry_3=L3.concarry;
gen concarry_4=L4.concarry;
gen concarry_5=L5.concarry;

gen precc_1=F1.concarry;
gen precc_2=F2.concarry;
gen precc_3=F3.concarry;
gen precc_4=F4.concarry;
gen precc_5=F5.concarry;



/* fix laws that have been repealed */

replace permitsr=0 if stnm=="MO" & year>1985;
replace permit_5=0 if stnm=="MO" & year>2007;
replace snsbansr=0 if stnm=="SC" & year>1978;
replace snsban_5=0 if stnm=="SC" & year>2012;
replace onegunsr=0 if stnm=="SC" & year>1978;
replace onegun_5=0 if stnm=="SC" & year>2004;
replace onegunsr=0 if stnm=="VA" & year>1998;
replace onegun_5=0 if stnm=="VA" & year>2012;

*list state year stnm lcm* if state==5;

/* lag suiratio because it is potentially endogenous */
gen suiratio_1=L.suiratio;
gen prcye_1=L.prcye;
gen police_1=L.police;
gen exec_1=L.exec;
gen aovio_1=L.aovio;
gen crrobpc_1=L.crrobpc;
gen crburpc_1=L.crburpc;

/* labels for tables */

label var syg_5 "Stand Your ground (SYG)law LR";
label var mmd_5 "Make my day (MMD) law LR";
label var shall_5 "Right to carry (RTC) law LR";
label var wait_5 "Waiting period LR";
label var bkgp_5 "Background checks for private sales LR";
label var fse_5 "Firearm sentencing enhancement LR";
label var safe_5 "Safe storage law LR";
label var jban_5 "Juvenile gun ban LR";
label var onegun_5 "One gun per month LR";
label var snsban_5 "Saturday night special ban LR";
label var permit_5 "Permit to purchase law LR";
label var lcm_5 "Large capacity magazine (LCM) ban LR";
label var lcmfedst_5 "State and Federal LCM ban LR";

label var sygsr "Stand Your ground (SYG)law SR";
label var mmdsr "Make my day (MMD) law SR";
label var shallsr "Right to carry (RTC) law SR";
label var waitsr "Waiting period SR";
label var bkgpsr "Background checks for private sales SR";
label var fsesr "Firearm sentencing enhancement SR";
label var safesr "Safe storage law SR";
label var jbansr "Juvenile gun ban SR";
label var onegunsr "One gun per month SR";
label var snsbansr "Saturday night special ban SR";
label var permitsr "Permit to purchase law SR";
label var lcmsr "Large capacity magazine (LCM) ban SR";
label var lcmfedstsr "State and Federal LCM ban SR";

label var strike3 "Three-strikes law";
label var tis "Truth-in-sentencing law";
label var suiratio_1 "Lag of firearm suicides/suicides";
label var prcye_1 "Lag of prison incarceration rate";
label var exec_1 "Lag of executions";
label var police_1 "Lag of police officers per capita";
label var aovio_1 "Lag of arrest rate for violent crime";
label var rtpi "Real income per capita";
label var unrate "Unemployment rate";
label var employ "Employment per capita";
label var empcon "Construction employment per capita";
label var empmil "Military employment per capita";
label var prate "Poverty rate";
label var rwel "Real welfare payments per capita";
label var al_spir "Distilled alcohol per capita";
label var al_wine "Wine per capita";
label var al_beer "Beer per capita";
label var density "Population density";
label var fryer "Crack cocaine";
label var pq1014 "Percent population 10-14";
label var pq1519 "Percent population 15-19";
label var pq2024 "Percent population 20-24";
label var pq2529 "Percent population 25-29";
label var pq3034 "Percent population 30-34";
label var pq3539 "Percent population 35-39";
label var pq4044 "Percent population 40-45";
label var pq4554 "Percent population 45-54";
label var pq5564 "Percent population 55-64";
label var pq6500 "Percent population 65+";
label var bmq1014 "Percent black male 10-14";
label var bmq1519 "Percent black male 15-19";
label var bmq2024 "Percent black male 20-24";
label var bmq2529 "Percent black male 25-29";
label var bmq3034 "Percent black male 30-34";
label var bmq3539 "Percent black male 35-39";
label var bmq4044 "Percent black male 40-45";
label var bmq4554 "Percent black male 45-54";
label var bmq5564 "Percent black male 55-64";
label var bmq6500 "Percent black male 65+";
label var earmur "Effective abortion rate";
label var crrobpc_1 "Lag robbery rate";
label var crburpc_1 "Lag burglary rate";
label var lcrmurpc_1 "Yt-1";
label var lcrmurpc_2 "Yt-2";

gen crviopc=100000*crvio/poptot;
gen lcrrobpc=100*log(100000*crrob/poptot);
gen lcrviopc=100*log(100000*crvio/poptot);
gen lcrasspc=100*log(100000*crass/poptot);



/* general model, unbiased */

areg lcrmurpc

precc_5 precc_4 precc_3 precc_2 precc_1
concarry
concarry_1 concarry_2 concarry_3 concarry_4 concarry_5 

lcm_5  syg_5 mmd_5 shall_5 fse_5  onegun_5  permit_5
lcmfedst_5  bkgp_5 wait_5 safe_5 jban_5 snsban_5
strike3_5 tis_5
lcmsr  sygsr mmdsr shallsr fsesr  onegunsr  permitsr
lcmfedstsr  bkgpsr waitsr safesr jbansr snsbansr
strike3sr tissr
prcye_1 exec_1 police_1 abortion 

crrobpc_1 crburpc_1 
unrate rtpi employ  empmil empcon  prate rwel
suiratio_1  al_spir al_beer al_wine fryer density
 pq1519  pq2024  pq2529  pq3034  pq3539  pq4044 pq4554 pq5564  pq6500
 bmq1519 bmq2024 bmq2529 bmq3034 bmq3539 bmq4044 bmq4554 bmq5564 bmq6500
L.lcrmurpc L2.lcrmurpc 

  yr* tr*
, absorb(state) cluster(state) ;

test concarry concarry_1 concarry_2 concarry_3 concarry_4 concarry_5 ;
scalar summur=_b[concarry] + _b[concarry_1]+  _b[concarry_2]+  _b[concarry_3] + _b[concarry_4] + _b[concarry_5] ;
scalar list;

quietly {;
/* save coeffs and sterrs  */
mata: b=st_matrix("e(b)");
mata: st_matrix("coeff",b);
mata: st_matrix_list("coeff");

/* coeffs and standard errors */
putexcel set coeffs, replace;
putexcel B2=matrix(coeff);
};

areg lcrasspc

precc_5 precc_4 precc_3 precc_2 precc_1
concarry
concarry_1 concarry_2 concarry_3 concarry_4 concarry_5 

lcm_5  syg_5 mmd_5 shall_5 fse_5  onegun_5  permit_5
lcmfedst_5  bkgp_5 wait_5 safe_5 jban_5 snsban_5
strike3_5 tis_5
lcmsr  sygsr mmdsr shallsr fsesr  onegunsr  permitsr
lcmfedstsr  bkgpsr waitsr safesr jbansr snsbansr
strike3sr tissr
prcye_1 exec_1 police_1 abortion 

crburpc_1 
unrate rtpi employ  empmil empcon  prate rwel
suiratio_1  al_spir al_beer al_wine fryer density
 pq1519  pq2024  pq2529  pq3034  pq3539  pq4044 pq4554 pq5564  pq6500
 bmq1519 bmq2024 bmq2529 bmq3034 bmq3539 bmq4044 bmq4554 bmq5564 bmq6500
L.lcrasspc L2.lcrasspc 

  yr* tr*
, absorb(state) cluster(state) ;

test concarry concarry_1 concarry_2 concarry_3 concarry_4 concarry_5 ;
scalar sumass=_b[concarry] + _b[concarry_1]+  _b[concarry_2]+  _b[concarry_3] + _b[concarry_4] + _b[concarry_5] ;
scalar list;

quietly {;
/* save coeffs and sterrs  */
mata: b=st_matrix("e(b)");
mata: st_matrix("coeff",b);
mata: st_matrix_list("coeff");

/* coeffs and standard errors */
putexcel set coeffs, modify;
putexcel B3=matrix(coeff);
};

areg lcrviopc

precc_5 precc_4 precc_3 precc_2 precc_1
concarry
concarry_1 concarry_2 concarry_3 concarry_4 concarry_5 

lcm_5  syg_5 mmd_5 shall_5 fse_5  onegun_5  permit_5
lcmfedst_5  bkgp_5 wait_5 safe_5 jban_5 snsban_5
strike3_5 tis_5
lcmsr  sygsr mmdsr shallsr fsesr  onegunsr  permitsr
lcmfedstsr  bkgpsr waitsr safesr jbansr snsbansr
strike3sr tissr
prcye_1 exec_1 police_1 abortion 

crburpc_1 
unrate rtpi employ  empmil empcon  prate rwel
suiratio_1  al_spir al_beer al_wine fryer density
 pq1519  pq2024  pq2529  pq3034  pq3539  pq4044 pq4554 pq5564  pq6500
 bmq1519 bmq2024 bmq2529 bmq3034 bmq3539 bmq4044 bmq4554 bmq5564 bmq6500
L.lcrviopc L2.lcrviopc 

  yr* tr*
, absorb(state) cluster(state) ;

test concarry concarry_1 concarry_2 concarry_3 concarry_4 concarry_5 ;
scalar sumvio=_b[concarry] + _b[concarry_1]+  _b[concarry_2]+  _b[concarry_3] + _b[concarry_4] + _b[concarry_5] ;
scalar list;

quietly {;
/* save coeffs and sterrs  */
mata: b=st_matrix("e(b)");
mata: st_matrix("coeff",b);
mata: st_matrix_list("coeff");

/* coeffs and standard errors */
putexcel set coeffs, modify;
putexcel B4=matrix(coeff);
};


log close;





